* pbp_mrx.sas;

libname out '.\sas_data_sets\PBP';

options pageno=1 nocenter ls=200;

data pbp_mrx;
  length
  pbp_a_hnumber                 $5
  pbp_a_plan_identifier         $3
  pbp_a_ben_cov                 $1
  pbp_a_plan_type               $2
  orgtype                       $2
  mrx_drug_ben_yn               $1
  mrx_formulary_yn              $1
  mrx_benefit_type              $1
  mrx_pen_lessexpen_yn          $1
  mrx_pen_oonpharm_yn           $1
  mrx_auth_ynba                 $1
  mrx_quantity_limits           $1
  mrx_locat                     $4
  mrx_inpp_ps                   $3
  mrx_innpp_presup              $3
  mrx_oonp_presup               $3
  mrx_mo_presup                 $3
  mrx_ae_cstshr_apply           $1
  mrx_ae_ooptcs_apply           $1
  mrx_ba_ded_charge             $1
  mrx_ba_cstshr_apply           $1
  mrx_ba_cov_lmt_yn             $1
  mrx_ba_ooptcs_apply           $1
  mrx_ea_ded_charge             $1
  mrx_ea_cstshr_apply           $1
  mrx_ea_cov_lmt_yn             $1
  mrx_ea_oop_th_yn              $1
  mrx_ea_cstshr_post_oopt       $1
  mrx_ea_sec_covlmt_icl_yn      $1
  mrx_ea_oop_th_yn_sec          $1
  mrx_ea_cstshr_post_oopt_sec   $1
  mrx_grp_type_id               $2
  mrx_grp_id                    $2
  mrx_grp_lbl                   $2
  mrx_grp_tierlbl               $50
  mrx_grp_type                  $3
  mrx_grp_locat                 $4
  mrx_grp_inpp_ps               $3
  mrx_grp_innpp_presup          $3
  mrx_grp_oonp_presup           $3
  mrx_grp_mo_presup             $3
  mrx_grp_lbl1                  $25
  mrx_grp_tier_lbl1             $50
  mrx_grp_coins_yn              $1
  mrx_grp_lbl2                  $25
  mrx_grp_tier_lbl2             $50
  mrx_grp_copay_yn              $1;

  infile '.\pbp\pbp_mrx.txt'
         delimiter = '09'x dsd lrecl = 20000 firstobs = 2 missover;
input
pbp_a_hnumber
pbp_a_plan_identifier
segment_id
pbp_a_ben_cov
pbp_a_plan_type
orgtype
mrx_ptd_nat_avg
mrx_drug_ben_yn
mrx_formulary_yn
mrx_benefit_type
mrx_pen_lessexpen_yn
mrx_pen_oonpharm_yn
mrx_auth_ynba
mrx_quantity_limits
mrx_locat
mrx_inpp_ps
mrx_inpp_1m_num
mrx_inpp_3m_num
mrx_inpp_co_num
mrx_innpp_presup
mrx_innpp_1m_num
mrx_innpp_3m_num
mrx_innpp_othnum
mrx_oonp_presup
mrx_oonp_1m_num
mrx_oonp_3m_num
mrx_oonp_othnumn
mrx_mo_presup
mrx_mo_1m_num
mrx_mo_3m_num
mrx_mo_othnum
mrx_ae_cstshr_apply
mrx_ae_cstshr_grps
mrx_ae_ooptcs_apply
mrx_ae_ot_grps
mrx_ba_ded_charge
mrx_ba_ded_amount
mrx_ba_cstshr_apply
mrx_ba_cstshr_grps
mrx_ba_cov_lmt_yn
mrx_ba_cov_lmt_amt
mrx_ba_ooptcs_apply
mrx_ba_ot_grps
mrx_ea_ded_charge
mrx_ea_ded_amount
mrx_ea_cstshr_apply
mrx_ea_cstshr_grps
mrx_ea_cov_lmt_yn
mrx_ea_cov_lmt_amt
mrx_ea_oop_th_yn
mrx_ea_oop_th_amt
mrx_ea_cstshr_post_oopt
mrx_ea_cstshr_group
mrx_ea_sec_covlmt_icl_yn
mrx_ea_sec_covlmt_icl_amt
mrx_ea_oop_th_yn_sec
mrx_ea_oop_th_amt_sec
mrx_ea_cstshr_post_oopt_sec
mrx_ea_cstshr_group_sec
mrx_grp_type_id
mrx_grp_id
mrx_grp_lbl
mrx_grp_tierlbl
mrx_grp_type
mrx_grp_locat
mrx_grp_inpp_ps
mrx_grp_inpp_1m_num
mrx_grp_inpp_3m_num
mrx_grp_inpp_co_num
mrx_grp_innpp_presup
mrx_grp_innpp_1m_num
mrx_grp_innpp_3m_num
mrx_grp_innpp_othnum
mrx_grp_oonp_presup
mrx_grp_oonp_1m_num
mrx_grp_oonp_3m_num
mrx_grp_oonp_othnumn
mrx_grp_mo_presup
mrx_grp_mo_1m_num
mrx_grp_mo_3m_num
mrx_grp_mo_othnum
mrx_grp_lbl1
mrx_grp_tier_lbl1
mrx_grp_coins_yn
mrx_grp_inpp_coins_1m
mrx_grp_inpp_coins_3m
mrx_grp_inpp_coins_os
mrx_grp_innpp_coins_1m
mrx_grp_innpp_coins_3m
mrx_grp_innpp_coins_os
mrx_grp_oonp_coins_1m
mrx_grp_oonp_coins_3m
mrx_grp_oonp_coins_os
mrx_grp_mo_coins_1m
mrx_grp_mo_coins_3m
mrx_grp_mo_coins_os
mrx_grp_lbl2
mrx_grp_tier_lbl2
mrx_grp_copay_yn
mrx_grp_inpp_copay_1m
mrx_grp_inpp_copay_3m
mrx_grp_inpp_copay_os
mrx_grp_innpp_copay_1m
mrx_grp_innpp_copay_3m
mrx_grp_innpp_copay_os
mrx_grp_oonp_copay_1m
mrx_grp_oonp_copay_3m
mrx_grp_oonp_copay_os
mrx_grp_mo_copay_1m
mrx_grp_mo_copay_3m
mrx_grp_mo_copay_os;

 label
  orgtype                     = 'Organization Type               '
  pbp_a_ben_cov               = 'Coverage Criteria               '
  pbp_a_hnumber               = 'H Number                        '
  pbp_a_plan_identifier       = 'Plan Identifier                 '
  segment_id                  = 'Segment ID                      '
  pbp_a_plan_type             = 'Select type of Plan             '
  mrx_ptd_nat_avg             = 'Part D National Average         '
  mrx_drug_ben_yn             = 'Part D Ben YN                   '
  mrx_formulary_yn            = 'Formulary YN                    '
  mrx_benefit_type            = 'Drug Benefit Type               '
  mrx_pen_lessexpen_yn        = 'Act Eq Pen Less Expen YN        '
  mrx_pen_oonpharm_yn         = 'Act Eq Pen OON Pharm YN         '
  mrx_auth_ynba               = 'Act Eq Authorization YN         '
  mrx_quantity_limits         = 'Quanty limts Yes or No?         '
  mrx_locat                   = 'Location                        '
  mrx_inpp_ps                 = 'In-Network Pref PS              '
  mrx_inpp_1m_num             = 'INPP 1M Supply Days             '
  mrx_inpp_3m_num             = 'INPP 3M Supply Days             '
  mrx_inpp_co_num             = 'INPP OthNum                     '
  mrx_innpp_presup            = 'INNPP Drgs                      '
  mrx_innpp_1m_num            = 'INNPP 1M Supply Days            '
  mrx_innpp_3m_num            = 'INNPP 3M Supply Days            '
  mrx_innpp_othnum            = 'INNPP OthNum                    '
  mrx_oonp_presup             = 'OONP PreSup                     '
  mrx_oonp_1m_num             = 'OONP 1M Supply Days             '
  mrx_oonp_3m_num             = 'OONP 3M Supply Days             '
  mrx_oonp_othnumn            = 'OONP OthNum                     '
  mrx_mo_presup               = 'MO Coins Pre Supply             '
  mrx_mo_1m_num               = 'MO 1M Supply Days               '
  mrx_mo_3m_num               = 'MO 3M Supply Days               '
  mrx_mo_othnum               = 'MO OthNum                       '
  mrx_ae_cstshr_apply         = 'AE Cost Share Pre-Intl Cov Lmt  '
  mrx_ae_cstshr_grps          = 'AE Cst Shr Group Number         '
  mrx_ae_ooptcs_apply         = 'AE OOP Threshold Application    '
  mrx_ae_ot_grps              = 'AE Post-OOPT Group #            '
  mrx_ba_ded_charge           = 'BA Deductible Charged YN        '
  mrx_ba_ded_amount           = 'BA Deductible Amount            '
  mrx_ba_cstshr_apply         = 'BA Cost Share Pre-Intl Cov Lmt  '
  mrx_ba_cstshr_grps          = 'BA Cst Shr Group Number         '
  mrx_ba_cov_lmt_yn           = 'Basic Alt Init Cov Lmt YN       '
  mrx_ba_cov_lmt_amt          = 'Basic Alt Init Cov Limit Amt    '
  mrx_ba_ooptcs_apply         = 'BA OOP Threshold Application    '
  mrx_ba_ot_grps              = 'BA Post-OOPT Group #            '
  mrx_ea_ded_charge           = 'EA Deductible Charged YN        '
  mrx_ea_ded_amount           = 'EA Deductible Amount            '
  mrx_ea_cstshr_apply         = 'EA Cost Share Pre-Intl Cov Lmt  '
  mrx_ea_cstshr_grps          = 'EA Cst Shr Group Number         '
  mrx_ea_cov_lmt_yn           = 'Enhan Alt Init Cov Lmt YN       '
  mrx_ea_cov_lmt_amt          = 'Enhan Alt Init Cov Limit Amt    '
  mrx_ea_oop_th_yn            = 'Enhanced Alt OOP Thrshld YN     '
  mrx_ea_oop_th_amt           = 'Enhan Alt OOPT Amt              '
  mrx_ea_cstshr_post_oopt     = 'EA Cost Share Post-OOPT         '
  mrx_ea_cstshr_group         = 'EA Cst Shr Group Number         '
  mrx_ea_sec_covlmt_icl_yn    = 'EA Secondary Init Cov Lmt YN    '
  mrx_ea_sec_covlmt_icl_amt   = 'EA Secondary Init Cov Lmt Amt   '
  mrx_ea_oop_th_yn_sec        = 'Enhanced Alt OOPTH YN Sec       '
  mrx_ea_oop_th_amt_sec       = 'Enhan Alt OOPT Sec Amt          '
  mrx_ea_cstshr_post_oopt_sec = 'EA Cost Share Post-OOPT Sec     '
  mrx_ea_cstshr_group_sec     = 'EA Cst Shr Group Number Sec     '
  mrx_grp_type_id             = 'Grp Type ID                     '
  mrx_grp_id                  = 'Grp ID                          '
  mrx_grp_lbl                 = 'Grp Label                       '
  mrx_grp_tierlbl             = 'Grp Tier Label                  '
  mrx_grp_type                = 'Group Drug Type(s)              '
  mrx_grp_locat               = 'Group Location                  '
  mrx_grp_inpp_ps             = 'Grp INPP Coins Pre Sply         '
  mrx_grp_inpp_1m_num         = 'GRP INPP 1M Supply Days         '
  mrx_grp_inpp_3m_num         = 'GRP INPP 3M Supply Days         '
  mrx_grp_inpp_co_num         = 'Grp INPP CO Othr Number         '
  mrx_grp_innpp_presup        = 'GRP INNPP Pre Sup               '
  mrx_grp_innpp_1m_num        = 'GRP INNPP 1M Supply Days        '
  mrx_grp_innpp_3m_num        = 'GRP INNPP 3M Supply Days        '
  mrx_grp_innpp_othnum        = 'Grp INNPP OthNum                '
  mrx_grp_oonp_presup         = 'Grp OONP PreSup                 '
  mrx_grp_oonp_1m_num         = 'GRP OONP 1M Supply Days         '
  mrx_grp_oonp_3m_num         = 'GRP OONP 3M Supply Days         '
  mrx_grp_oonp_othnumn        = 'Grp OONP OthNum                 '
  mrx_grp_mo_presup           = 'Grp MO Coins Pre Supply         '
  mrx_grp_mo_1m_num           = 'GRP MO 1M Supply Days           '
  mrx_grp_mo_3m_num           = 'GRP MO 3M Supply Days           '
  mrx_grp_mo_othnum           = 'Grp MO OthNum                   '
  mrx_grp_lbl1                = 'Medicare Rx Grp Label Name      '
  mrx_grp_tier_lbl1           = 'Medicare Rx Grp Tier Label      '
  mrx_grp_coins_yn            = 'Grp Coinsurance Y/N             '
  mrx_grp_inpp_coins_1m       = 'Grp INPP Coins 1M               '
  mrx_grp_inpp_coins_3m       = 'Grp INPP Coins 3M               '
  mrx_grp_inpp_coins_os       = 'Grp INPP Coins OS               '
  mrx_grp_innpp_coins_1m      = 'Grp INNPP Coins 1M              '
  mrx_grp_innpp_coins_3m      = 'Grp INNPP Coins 3M              '
  mrx_grp_innpp_coins_os      = 'Grp INNPP Coins OS              '
  mrx_grp_oonp_coins_1m       = 'Grp OONP Coins 1M               '
  mrx_grp_oonp_coins_3m       = 'Grp OONP Coins 3M               '
  mrx_grp_oonp_coins_os       = 'Grp OONP Coins OS               '
  mrx_grp_mo_coins_1m         = 'Grp Mail Order Coins 1M         '
  mrx_grp_mo_coins_3m         = 'Grp Mail Order Coins 3M         '
  mrx_grp_mo_coins_os         = 'Grp Mail Order Coins OS         '
  mrx_grp_lbl2                = 'Medicare Rx Grp Label Name      '
  mrx_grp_tier_lbl2           = 'Medicare Rx Grp Tier Label      '
  mrx_grp_copay_yn            = 'Grp Copay YN                    '
  mrx_grp_inpp_copay_1m       = 'Grp INPP Copay Amt 1M           '
  mrx_grp_inpp_copay_3m       = 'Grp INPP Copay Amt 3M           '
  mrx_grp_inpp_copay_os       = 'Grp INPP Copay Amt OS           '
  mrx_grp_innpp_copay_1m      = 'Grp INNPP Copay Amt 1M          '
  mrx_grp_innpp_copay_3m      = 'Grp INNPP Copay Amt 3M          '
  mrx_grp_innpp_copay_os      = 'Grp INNPP Copay Amt OS          '
  mrx_grp_oonp_copay_1m       = 'Grp OONP Copay  Amt 1M          '
  mrx_grp_oonp_copay_3m       = 'Grp OONP Copay Amt 3M           '
  mrx_grp_oonp_copay_os       = 'Grp OONP Copay Amt OS           '
  mrx_grp_mo_copay_1m         = 'Grp Mail Order Copay Amt 1M     '
  mrx_grp_mo_copay_3m         = 'Grp Mail Order Copay Amt 3M     '
  mrx_grp_mo_copay_os         = 'Grp Mail Order Copay Amt OS     ';
run;

proc sort data = pbp_mrx out = out.pbp_mrx;
   by pbp_a_hnumber pbp_a_plan_identifier segment_id mrx_benefit_type mrx_grp_id mrx_grp_type_id;
run;

proc print data = out.pbp_mrx (obs = 10);
  title 'pbp mrx data';
run;

proc means data =  out.pbp_mrx;
  title 'pbp mrx file';
run;

proc freq data = out.pbp_mrx;
  table
  mrx_drug_ben_yn  mrx_formulary_yn mrx_benefit_type mrx_pen_lessexpen_yn
  mrx_pen_oonpharm_yn mrx_auth_ynba mrx_quantity_limits mrx_inpp_ps
  mrx_innpp_presup mrx_oonp_presup mrx_mo_presup mrx_ae_cstshr_apply
  mrx_ae_ooptcs_apply mrx_ba_ded_charge mrx_ba_cstshr_apply mrx_ba_cov_lmt_yn
  mrx_ba_ooptcs_apply mrx_ea_ded_charge mrx_ea_cstshr_apply mrx_ea_cov_lmt_yn
  mrx_ea_oop_th_yn mrx_ea_cstshr_post_oopt mrx_ea_sec_covlmt_icl_yn mrx_grp_id
  mrx_ea_oop_th_yn_sec mrx_ea_cstshr_post_oopt_sec mrx_grp_type mrx_grp_type_id
  mrx_grp_inpp_ps mrx_grp_innpp_presup mrx_grp_oonp_presup mrx_grp_mo_presup
  mrx_grp_coins_yn mrx_grp_copay_yn / missing;
  run;

proc contents data = out.pbp_mrx;
  title 'pbp mrx data';
run;
